class kaminario::cinder (
  $ensure                     = present,    # could be present or absent
  $san_user               = 'admin',
  $san_password           = 'admin',
  $san_ip                 = '127.0.0.1',
  $backend_name           = 'kaminario_fc',
  $protocol		  = 'fc',
  $default_volume_type    = '',
  $report_discard_supported = 'true',
  $is_multipath_enabled	  = 'true',
  $section_name           = 'kaminario_fc_127.0.0.1',
  $rel_version            = '7',
  $rel_name		  = 'mitaka',
  $scheduler_default_filters = '',
  $scheduler_default_weighers = '',
  $rpc_response_timeout=  '',
  $suppress_requests_ssl_warnings= '',
  $filter_function        = '',
  $goodness_function        = '',
  $enforce_multipath_for_image_xfer = '',
  $auto_calc_max_oversubscription_ratio = '',
  $replication_device = '',
  $cinder_config_file         = '/etc/cinder/cinder.conf',
)
{
  notify {'Configure Cinder to use Kaminario driver': }

  $cinder_volume_service = $::osfamily ? {
    'RedHat' => 'openstack-cinder-volume',
    'Debian' => 'cinder-volume',
  }

  if ! $::cinder_path {
    warning('Cinder is not installed on this node')
  }
	if $rel_version == '7' or  $rel_version == '8' {
		file { "/usr/lib/python2.7/dist-packages/cinder/volume/drivers/kaminario":
        	ensure => "directory",
	        owner  => "root",
	        group  => "root",
        	mode   => 755,}
   
                file { "/usr/lib/python2.7/dist-packages/cinder/tests/unit/volume/drivers":
                ensure => "directory",
                owner  => "root",
                group  => "root",
                mode   => 755,}

		file { "/usr/lib/python2.7/dist-packages/cinder/volume/drivers/kaminario/__init__.py":
	        mode   => 644,
        	owner  => root,
	        group  => root,
        	source => "puppet:///modules/kaminario/__init__.py"}

		file { "/usr/lib/python2.7/dist-packages/cinder/volume/drivers/kaminario/kaminario_common.py":
	        mode   => 644,
        	owner  => root,
	        group  => root,
        	source => "puppet:///modules/kaminario/kaminario_common.py"}

		file { "/usr/lib/python2.7/dist-packages/cinder/volume/drivers/kaminario/kaminario_fc.py":
	        mode   => 644,
        	owner  => root,
	        group  => root,
	        source => "puppet:///modules/kaminario/kaminario_fc.py"}

		file { "/usr/lib/python2.7/dist-packages/cinder/volume/drivers/kaminario/kaminario_iscsi.py":
	        mode   => 644,
	        owner  => root,
	        group  => root,
	        source => "puppet:///modules/kaminario/kaminario_iscsi.py"}

                file { "/usr/lib/python2.7/dist-packages/cinder/tests/unit/volume/drivers/test_kaminario.py":
                mode   => 644,
                owner  => root,
                group  => root,
                source => "puppet:///modules/kaminario/test_kaminario.py"}
	}

		if $protocol == 'fc' {
			ini_setting { 'volume_driver':
                                path    => $cinder_config_file,
                                section => $section_name,
                                setting => 'volume_driver',
                                value   => 'cinder.volume.drivers.kaminario.kaminario_fc.KaminarioFCDriver',
                        }
		}
		elsif $protocol == 'iscsi' {
                        ini_setting { 'volume_driver':
                                path    => $cinder_config_file,
                                section => $section_name,
                                setting => 'volume_driver',
                                value   => 'cinder.volume.drivers.kaminario.kaminario_iscsi.KaminarioISCSIDriver',
                        }
                }
		if $default_volume_type != '' {
	      		ini_setting { 'default_volume_type':
	        		path    => $cinder_config_file,
				section => 'DEFAULT',
			        setting => 'default_volume_type',
				value   => $default_volume_type,
		      	}
		}
                ini_setting { 'default_volume_type1':
                                path    => $cinder_config_file,
                                section => 'DEFAULT',
                                setting => 'verbose',
                                value   => 'True',
                        }
                ini_setting { 'default_volume_type2':
                                path    => $cinder_config_file,
                                section => 'DEFAULT',
                                setting => 'debug',
                                value   => 'True',
                        }
		
                if $rel_version != '7' {
                   if $report_discard_supported == 'true' or $report_discard_supported == 'True' {
                           ini_setting { 'report_discard_supported':
                                   path    => $cinder_config_file,
                                   section => $section_name,
                                   setting => 'report_discard_supported',
                                   value   => $report_discard_supported,
                        }
                }
             }
		ini_setting { 'volume_backend_name':
	        	path    => $cinder_config_file,
		        section => $section_name,
			setting => 'volume_backend_name',
			value   => $backend_name,
	      	} ->
	      	ini_setting { 'san_ip':
		       	path    => $cinder_config_file,
		        section => $section_name,
		       	setting => 'san_ip',
		        value   => $san_ip,
	      	} ->
	      	ini_setting { 'san_user':
	        	path    => $cinder_config_file,
		        section => $section_name,
		        setting => 'san_login',
		        value   => $san_user,
	     	} ->
		ini_setting { 'san_password':
			path    => $cinder_config_file,
		        section => $section_name,
		        setting => 'san_password',
	        	value   => $san_password,
	     	}	 
		if $suppress_requests_ssl_warnings != '' {
	           	ini_setting { 'suppress_requests_ssl_warnings':
	        		path    => $cinder_config_file,
        	        	section => $section_name,
	        	        setting => 'suppress_requests_ssl_warnings',
        	        	value   => $suppress_requests_ssl_warnings,
	             		}
		}
		if $filter_function != '' {
             		ini_setting { 'filter_function':
		               	path    => $cinder_config_file,
		                section => $section_name,
        		       	setting => 'filter_function',
	                	value   => $filter_function,
			}
		}
		if $goodness_function != '' {
			ini_setting { 'goodness_function':
				path    => $cinder_config_file,
				section => $section_name,
				setting => 'goodness_function',
				value   => $goodness_function,
			}
		}
		if $is_multipath_enabled == 'true' or $is_multipath_enabled == 'True' {
			ini_setting { 'use_multipath_for_image_xfer':
				path    => $cinder_config_file,
        	        	section => $section_name,
	        	        setting => 'use_multipath_for_image_xfer',
        	        	value   => 'True',
			}
		}
		if $enforce_multipath_for_image_xfer == 'true' and $is_multipath_enabled == 'true' {
			ini_setting { 'enforce_multipath_for_image_xfer':
		                path    => $cinder_config_file,
		                section => $section_name,
		                setting => 'enforce_multipath_for_image_xfer',
                		value   => $enforce_multipath_for_image_xfer,
			}
		}
		if $auto_calc_max_oversubscription_ratio != '' { 
            		ini_setting { 'auto_calc_max_oversubscription_ratio':
			       	path    => $cinder_config_file,
		                section => $section_name,
		                setting => 'auto_calc_max_oversubscription_ratio',
		                value   => $auto_calc_max_oversubscription_ratio,
			}
		}
		if $scheduler_default_filters != '' {
			ini_setting { 'scheduler_default_filters':
	        	        path    => $cinder_config_file,
	        	        section => 'DEFAULT',
        		        setting => 'scheduler_default_filters',
		                value   => $scheduler_default_filters,
			}
		}
		if $scheduler_default_weighers != '' {
			ini_setting { 'scheduler_default_weighers':
		                path    => $cinder_config_file,
		                section => 'DEFAULT',
		                setting => 'scheduler_default_weighers',
                		value   => $scheduler_default_weighers,
             		}
		}
		if $replication_device != '' {
			ini_setting { 'replication_device':
		                path    => $cinder_config_file,
                		section => $section_name,
		                setting => 'replication_device',
                		value   => $replication_device,
		     	}
		}
		if $rpc_response_timeout != '' {
			ini_setting { 'rpc_response_timeout':
		                path    => $cinder_config_file,
                		section => 'DEFAULT',
		                setting => 'rpc_response_timeout',
                		value   => $rpc_response_timeout,
			} ~> Service[cinder_volume] 
		}
		service { 'cinder_volume':
      			ensure     => running,
		      	name       => 'cinder-volume',
      			enable     => true,
      			hasstatus  => true,
	      		hasrestart => true,
		}
    	}

