class kaminario::nova (
  $ensure                 = present,    # could be present or absent
  $is_multipath_enabled   = 'true',
  $nova_config_file       = '/etc/nova/nova.conf',
)
{
        notify {'Configure nova to use Kaminario driver': }

	 ini_setting { 'default_volume_type1':
                                path    => $nova_config_file,
                                section => 'DEFAULT',
                                setting => 'verbose',
                                value   => 'True',
                        }
                ini_setting { 'default_volume_type2':
                                path    => $nova_config_file,
                                section => 'DEFAULT',
                                setting => 'debug',
                                value   => 'True',
                        }
        ini_subsetting { 'iscsi_use_multipath':
                path    => $nova_config_file,
                section => 'libvirt',
		setting => 'iscsi_use_multipath',
                subsetting => $is_multipath_enabled,
	} ~> Service[nova_compute]
			service { 'nova_compute':
			ensure     => running,
			name       => 'nova-compute',
			enable     => true,
			hasstatus  => true,
			hasrestart => true,
	}
}
